#pragma once

namespace harp {
namespace constants {
double const Rgas = 8.314462;
double const Rgas_cgs = 8.314462E7;
double const kBoltz = 1.3806504E-23;
double const kBoltz_cgs = 1.3806504E-16;
double const Lo = 2.68719E25;

//! Avogadro's Number @f$ N_{\mathrm{A}} @f$ [number/mol]
double const Avogadro = 6.02214179E23;

double const hPlanck = 6.62606957E-34;
double const hPlanck_cgs = 6.62606957e-27;
double const cLight = 2.99792458E8;
double const cLight_cgs = 2.99792458E10;
double const stefanBoltzmann = 5.670374419E-8;

//! Electron Mass @f$ m_e @f$ [kg]
const double ElectronMass = 9.1093837015e-31;
}  // namespace constants
}  // namespace harp
